<?php
if($apo->loged && $apo->userAdmin){
	if(!empty($_POST["action"])){
		import("com.incutio.HttpClient");
		include_once dirname(__FILE__)."/../general/functions_html.inc";
		
		$getAction = $_POST["action"];
		
		$stopAction = false;
		
		// Récupération de la version
		$file = $apo->serverRoot."/version";
		$getVersion = @file_get_contents($file);
		if($getVersion === false){
			$stopAction = true;
			$apo->error = $apo->getText("error7")." : ".$file;
		}
		// Récupération de la liste des releases
		$file = $apo->updateUrl."/releases.xml";
		$fileContent = HttpClient::quickGet($file);
		if($fileContent === false){
			$stopAction = true;
			$apo->error = $apo->getText("error8")." (".$file.")";
		}
		// Recherche des releases à installer
		if(!$stopAction){
			$releases = @simplexml_load_string($fileContent);
			$releasesFile = array();
			foreach ($releases->children() as $nextRelease) {
				if(version_compare($nextRelease["version"], $getVersion, ">")){
					$releasesFile[] = (string) $nextRelease["file"];
				}
			}
			if(count($releasesFile) == 0){
				$stopAction = true;
				$apo->message = $apo->getText("message0");
			}
		}
		
		// Suivant l'action demandée, on fait des choses différentes, évidemment pff lol
		if(!$stopAction){
			switch($getAction){
				case "update":
					// Pour chaque release, exécuter et installer ce qu'il faut
					reset($releasesFile);
					foreach($releasesFile as $file){
						// Récupération du contenu du fichier de release
						$fileContent = HttpClient::quickGet($apo->updateUrl."/".$file);
						if($fileContent === false){
							// Erreur de lecture du fichier de release
							$stopAction = true;
							$apo->error = $apo->getText("error8")." (".$apo->updateUrl."/".$file.")";
							break;
						}else{
							// On peut parser le fichier de release
							$release = simplexml_load_string($fileContent);
							foreach ($release->children() as $nextTag => $nextStep) {
								switch((string) $nextTag){
									// Un script à exécuter
									case "script":
										$result = @eval((string) $nextStep);
										if($result === false){
											$stopAction = true;
											$apo->error = $apo->getText("error8")." (".$apo->updateUrl."/".$file.")";
										}
										break;
									// Un contenu à mettre dans un fichier
									case "content":
										$content = (string) $nextStep;
										$target = $apo->serverRoot."/".$nextStep["target"];
										$targetFile = @fopen($target, "w");
										if($targetFile === false){
											$stopAction = true;
											$apo->error = $apo->getText("error7")." : ".$target;
										}else{
											fwrite($targetFile, $content);
											fclose($targetFile);
										}
										break;
									// Un fichier à mettre à jour
									case "file":
										$src = $apo->updateUrl."/files/".$nextStep["src"];
										$target = $apo->serverRoot."/".$nextStep["target"];
										$srcContent = HttpClient::quickGet($src);
										if($srcContent === false){
											$stopAction = true;
											$apo->error = $apo->getText("error8")." (".$src.")";
										}else{
											$targetFile = @fopen($target, "wb");
											if($targetFile === false){
												$stopAction = true;
												$apo->error = $apo->getText("error7")." : ".$target;
											}else{
												fwrite($targetFile, $srcContent);
												fclose($targetFile);
											}
										}
										break;
								}
							}
						}
						if($stopAction){
							break;
						}
					}
					
					// Mise à jour terminée
					if(!$stopAction){
						$apo->message = $apo->getText("message0");
					}
					break;
				case "show":
					$description = "";
					
					reset($releasesFile);
					foreach($releasesFile as $file){
						// Récupération du contenu du fichier de release
						$fileContent = HttpClient::quickGet($apo->updateUrl."/".$file);
						if($fileContent === false){
							// Erreur de lecture du fichier de release
							$stopAction = true;
							$apo->error = $apo->getText("error8")." (".$apo->updateUrl."/".$file.")";
							break;
						}else{
							// On peut parser le fichier de release
							$release = simplexml_load_string($fileContent);
							$description .= "\n<h3>Version ".$release["version"]."</h3>\n";
							$description .= nl2br(trim(utf2html(htmlentities($release->description, ENT_QUOTES, "UTF-8"))));
						}
						if($stopAction){
							break;
						}
					}
					break;
			}
		}
	}
}
?>